unit Keyboard;

interface

type

  keyblock = record
    L: integer;		{ left }
    T: integer;		{ top }
    W: integer;		{ width of the key }
    H: integer;		{ height of the key }
    SX: integer;	{ horizontal spacing }
    SY: integer;	{ vertical spacing }
    col: integer;	{ number of columns }
    cnt: integer;	{ number of keys in a block }
  end;

  function KeyRead : pointer;

const

  KEYPADS = 5;		{index of the last item in the 'keypad' array}
  LASTKEYCODE = 77;

  keypad: array[0..KEYPADS] of keyblock = (
{ code: 1..10 }
    (	L:53;	T:335;	W:40;	H:20;	SX:63;	SY:54;	col:5;	cnt:10	),
{ code: 11 }
    (	L:53;	T:442;	W:40;	H:20;	SX:63;	SY:54;	col:1;	cnt:1	),
{ code: 12..15 }
    (	L:117;	T:436;	W:40;	H:30;	SX:63;	SY:42;	col:10;	cnt:4	),
{ code: 16..35 }
    (	L:53;	T:490;	W:40;	H:30;	SX:63;	SY:53;	col:5;	cnt:20	),
{ code: 36..75 }
    (	L:419;	T:153;	W:59;	H:57;	SX:64;	SY:64;	col:5;	cnt:40	),
{ code: 76..77 }
    (	L:474;	T:67;	W:75;	H:50;	SX:127;	SY:64;	col:2;	cnt:2	)
  );


implementation

uses Def;

const

{ table converting KeyCode1 and KeyCode2 to the keyboard state }
  KeyTab: array[0..LASTKEYCODE+4] of word = (
	$0000,					{ 0: no key pressed }
	$0006, $000A, $0012, $0014, $000C,	{ 1..5: tel memo up arr_left arr_right }
	$0820, $0420, $0220, $1400, $0C00,	{ 6..10: file search down left right }
        $1020,					{ 11: key }
	       $1040, $0120, $00A0, $0060,	{ 12..15: "S" "SK" sqr % }
	$0840, $0440, $0240, $0140, $00C0,	{ 16..20: 7 8 9 div "SP" }
	$1080, $0880, $0480, $0280, $0180,	{ 21..25: 4 5 6 mul M->x }
	$0009, $1100, $0900, $0500, $0300,	{ 26..30: 1 2 3 - M- }
	$0005, $0018, $1200, $0A00, $1800,	{ 31..35: 0 . = + M+ }
	$0404, $0402, $0408, $0011, $0410,	{ 36..40: "VV" Func "VN" "UD" "SI" }
	$0024, $0022, $0028, $0021, $0030,	{ 41..45: A B V G D }
	$0044, $0042, $0048, $0041, $0050,	{ 46..50: E JO ZH Z I }
	$0084, $0082, $0088, $0081, $0090,	{ 51..55: J K L M N }
	$0104, $0102, $0108, $0101, $0110,	{ 56..60: O P R S T }
	$0204, $0202, $0208, $0201, $0210,	{ 61..65: U F H C CH }
	$0804, $0802, $0808, $0801, $0810,	{ 66..70: SH SHH Y mj.znak JE }
	$1004, $1002, $1008, $1001, $1010,	{ 71..75: JU JA space rect. rhombus }
	$0401, $0003,                           { 76..77: on off }
        $1570,					{ 78: memory init }
        $15B0,					{ 79: reveal password }
        $11E2,					{ 80: about the author }
        $11F0 );				{ 81: }
  function KeyRead : pointer;
  begin
    kbdcols := KeyTab[KeyCode1] or KeyTab[KeyCode2];
    KeyRead := @kbdcols;
  end {KeyRead};

end.
